(function (_, kotlin_kotlin, kotlin_com_zegreatrob_tools_digger_core) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var split = kotlin_kotlin.$_$.qc;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.e5;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.j;
  var toInt = kotlin_kotlin.$_$.dd;
  var Unit_instance = kotlin_kotlin.$_$.g4;
  var charSequenceLength = kotlin_kotlin.$_$.w8;
  var charSequenceGet = kotlin_kotlin.$_$.v8;
  var digitToIntOrNull = kotlin_kotlin.$_$.nb;
  var emptyList = kotlin_kotlin.$_$.w5;
  var VOID = kotlin_kotlin.$_$.f;
  var protoOf = kotlin_kotlin.$_$.da;
  var getStringHashCode = kotlin_kotlin.$_$.f9;
  var hashCode = kotlin_kotlin.$_$.g9;
  var THROW_CCE = kotlin_kotlin.$_$.fe;
  var equals = kotlin_kotlin.$_$.a9;
  var classMeta = kotlin_kotlin.$_$.y8;
  var setMetadataFor = kotlin_kotlin.$_$.ea;
  var enumEntries = kotlin_kotlin.$_$.m8;
  var Enum = kotlin_kotlin.$_$.xd;
  var ArrayList_init_$Create$_0 = kotlin_kotlin.$_$.k;
  var isCharSequence = kotlin_kotlin.$_$.m9;
  var trim = kotlin_kotlin.$_$.od;
  var toString = kotlin_kotlin.$_$.ia;
  var Companion_instance = kotlin_kotlin.$_$.b4;
  var get = kotlin_kotlin.$_$.sb;
  var _Result___init__impl__xyqfz8 = kotlin_kotlin.$_$.b2;
  var createFailure = kotlin_kotlin.$_$.te;
  var _Result___get_isFailure__impl__jpiriv = kotlin_kotlin.$_$.d2;
  var _Result___get_value__impl__bjfvqg = kotlin_kotlin.$_$.f2;
  var substringBefore = kotlin_kotlin.$_$.vc;
  var contains = kotlin_kotlin.$_$.lb;
  var to = kotlin_kotlin.$_$.ef;
  var _Result___get_isSuccess__impl__sndoy8 = kotlin_kotlin.$_$.e2;
  var Result__exceptionOrNull_impl_p6xea9 = kotlin_kotlin.$_$.c2;
  var mapOf = kotlin_kotlin.$_$.z6;
  var LinkedHashMap_init_$Create$ = kotlin_kotlin.$_$.t;
  var joinToString = kotlin_kotlin.$_$.k6;
  var objectMeta = kotlin_kotlin.$_$.ca;
  var Defaults_getInstance = kotlin_com_zegreatrob_tools_digger_core.$_$.a;
  //endregion
  //region block: pre-declaration
  setMetadataFor(VersionResult, 'VersionResult', classMeta);
  setMetadataFor(SnapshotReason, 'SnapshotReason', classMeta, Enum);
  setMetadataFor(SnapshotReason$DIRTY, 'DIRTY', classMeta, SnapshotReason);
  setMetadataFor(SnapshotReason$AHEAD, 'AHEAD', classMeta, SnapshotReason);
  setMetadataFor(SnapshotReason$BEHIND, 'BEHIND', classMeta, SnapshotReason);
  setMetadataFor(SnapshotReason$NOT_RELEASE_BRANCH, 'NOT_RELEASE_BRANCH', classMeta, SnapshotReason);
  setMetadataFor(SnapshotReason$NO_NEW_VERSION, 'NO_NEW_VERSION', classMeta, SnapshotReason);
  setMetadataFor(StatusCheck, 'StatusCheck', classMeta);
  setMetadataFor(ChangeType, 'ChangeType', classMeta, Enum);
  setMetadataFor(ChangeType$Major, 'Major', classMeta, ChangeType);
  setMetadataFor(ChangeType$Minor, 'Minor', classMeta, ChangeType);
  setMetadataFor(ChangeType$Patch, 'Patch', classMeta, ChangeType);
  setMetadataFor(ChangeType$None, 'None', classMeta, ChangeType);
  setMetadataFor(TagErrors, 'TagErrors', objectMeta);
  setMetadataFor(TagResult, 'TagResult', classMeta);
  setMetadataFor(Success, 'Success', objectMeta, TagResult);
  setMetadataFor(Error_0, 'Error', classMeta, TagResult);
  setMetadataFor(TaggerCore, 'TaggerCore', classMeta);
  setMetadataFor(Defaults, 'Defaults', objectMeta);
  setMetadataFor(Companion, 'Companion', objectMeta);
  setMetadataFor(VersionRegex, 'VersionRegex', classMeta);
  //endregion
  function asSemverComponents(_this__u8e3s4) {
    // Inline function 'kotlin.collections.map' call
    var this_0 = split(stripPrefix(_this__u8e3s4), ['.']);
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(this_0, 10));
    var tmp0_iterator = this_0.t();
    while (tmp0_iterator.u()) {
      var item = tmp0_iterator.w();
      var tmp$ret$0 = toInt(item);
      destination.q(tmp$ret$0);
    }
    return destination;
  }
  function stripPrefix(_this__u8e3s4) {
    var tmp$ret$1;
    $l$block: {
      // Inline function 'kotlin.text.indexOfFirst' call
      var inductionVariable = 0;
      var last = charSequenceLength(_this__u8e3s4) - 1 | 0;
      if (inductionVariable <= last)
        do {
          var index = inductionVariable;
          inductionVariable = inductionVariable + 1 | 0;
          // Inline function 'com.zegreatrob.tools.tagger.core.stripPrefix.<anonymous>' call
          var it = charSequenceGet(_this__u8e3s4, index);
          if (!(digitToIntOrNull(it) == null)) {
            tmp$ret$1 = index;
            break $l$block;
          }
        }
         while (inductionVariable <= last);
      tmp$ret$1 = -1;
    }
    var startIndex = tmp$ret$1;
    // Inline function 'kotlin.text.substring' call
    // Inline function 'kotlin.js.asDynamic' call
    return _this__u8e3s4.substring(startIndex);
  }
  function VersionResult(version, snapshotReasons) {
    snapshotReasons = snapshotReasons === VOID ? emptyList() : snapshotReasons;
    this.h1i_1 = version;
    this.i1i_1 = snapshotReasons;
  }
  protoOf(VersionResult).toString = function () {
    return 'VersionResult(version=' + this.h1i_1 + ', snapshotReasons=' + this.i1i_1 + ')';
  };
  protoOf(VersionResult).hashCode = function () {
    var result = getStringHashCode(this.h1i_1);
    result = imul(result, 31) + hashCode(this.i1i_1) | 0;
    return result;
  };
  protoOf(VersionResult).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof VersionResult))
      return false;
    var tmp0_other_with_cast = other instanceof VersionResult ? other : THROW_CCE();
    if (!(this.h1i_1 === tmp0_other_with_cast.h1i_1))
      return false;
    if (!equals(this.i1i_1, tmp0_other_with_cast.i1i_1))
      return false;
    return true;
  };
  function SnapshotReason$DIRTY() {
    SnapshotReason.call(this, 'DIRTY', 0);
    SnapshotReason_DIRTY_instance = this;
  }
  protoOf(SnapshotReason$DIRTY).l1i = function (_this__u8e3s4) {
    return !_this__u8e3s4.m1i_1.t1h_1;
  };
  var SnapshotReason_DIRTY_instance;
  function SnapshotReason$AHEAD() {
    SnapshotReason.call(this, 'AHEAD', 1);
    SnapshotReason_AHEAD_instance = this;
  }
  protoOf(SnapshotReason$AHEAD).l1i = function (_this__u8e3s4) {
    return !(_this__u8e3s4.m1i_1.u1h_1 === 0);
  };
  var SnapshotReason_AHEAD_instance;
  function SnapshotReason$BEHIND() {
    SnapshotReason.call(this, 'BEHIND', 2);
    SnapshotReason_BEHIND_instance = this;
  }
  protoOf(SnapshotReason$BEHIND).l1i = function (_this__u8e3s4) {
    return !(_this__u8e3s4.m1i_1.v1h_1 === 0);
  };
  var SnapshotReason_BEHIND_instance;
  function SnapshotReason$NOT_RELEASE_BRANCH() {
    SnapshotReason.call(this, 'NOT_RELEASE_BRANCH', 3);
    SnapshotReason_NOT_RELEASE_BRANCH_instance = this;
  }
  protoOf(SnapshotReason$NOT_RELEASE_BRANCH).l1i = function (_this__u8e3s4) {
    return !(_this__u8e3s4.m1i_1.w1h_1 === _this__u8e3s4.n1i_1);
  };
  var SnapshotReason_NOT_RELEASE_BRANCH_instance;
  function SnapshotReason$NO_NEW_VERSION() {
    SnapshotReason.call(this, 'NO_NEW_VERSION', 4);
    SnapshotReason_NO_NEW_VERSION_instance = this;
  }
  protoOf(SnapshotReason$NO_NEW_VERSION).l1i = function (_this__u8e3s4) {
    return _this__u8e3s4.o1i_1 === _this__u8e3s4.p1i_1;
  };
  var SnapshotReason_NO_NEW_VERSION_instance;
  function values() {
    return [SnapshotReason_DIRTY_getInstance(), SnapshotReason_AHEAD_getInstance(), SnapshotReason_BEHIND_getInstance(), SnapshotReason_NOT_RELEASE_BRANCH_getInstance(), SnapshotReason_NO_NEW_VERSION_getInstance()];
  }
  function get_entries() {
    if ($ENTRIES == null)
      $ENTRIES = enumEntries(values());
    return $ENTRIES;
  }
  var SnapshotReason_entriesInitialized;
  function SnapshotReason_initEntries() {
    if (SnapshotReason_entriesInitialized)
      return Unit_instance;
    SnapshotReason_entriesInitialized = true;
    SnapshotReason_DIRTY_instance = new SnapshotReason$DIRTY();
    SnapshotReason_AHEAD_instance = new SnapshotReason$AHEAD();
    SnapshotReason_BEHIND_instance = new SnapshotReason$BEHIND();
    SnapshotReason_NOT_RELEASE_BRANCH_instance = new SnapshotReason$NOT_RELEASE_BRANCH();
    SnapshotReason_NO_NEW_VERSION_instance = new SnapshotReason$NO_NEW_VERSION();
  }
  var $ENTRIES;
  function SnapshotReason(name, ordinal) {
    Enum.call(this, name, ordinal);
  }
  protoOf(SnapshotReason).s1i = function (check) {
    return this.l1i(check);
  };
  function calculateNextVersion(_this__u8e3s4, implicitPatch, versionRegex, releaseBranch) {
    var tmp0_elvis_lhs = lastVersionAndTag(_this__u8e3s4);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      return new VersionResult('0.0.0');
    } else {
      tmp = tmp0_elvis_lhs;
    }
    var tmp1_container = tmp;
    var previousVersionNumber = tmp1_container.r6();
    var lastTagDescription = tmp1_container.s6();
    var incrementComponent = findAppropriateIncrement(_this__u8e3s4.b1j_1, lastTagDescription, implicitPatch, versionRegex);
    var tmp3_elvis_lhs = incrementComponent == null ? null : incrementComponent.f1j(asSemverComponents(previousVersionNumber));
    var currentVersionNumber = tmp3_elvis_lhs == null ? previousVersionNumber : tmp3_elvis_lhs;
    var reasonsToUseSnapshot = snapshotReasons(_this__u8e3s4, releaseBranch, currentVersionNumber, previousVersionNumber);
    var tmp_0;
    if (reasonsToUseSnapshot.a1()) {
      tmp_0 = new VersionResult(currentVersionNumber);
    } else {
      tmp_0 = new VersionResult(currentVersionNumber + '-SNAPSHOT', reasonsToUseSnapshot);
    }
    return tmp_0;
  }
  function StatusCheck(gitStatus, releaseBranch, currentVersionNumber, previousVersionNumber) {
    this.m1i_1 = gitStatus;
    this.n1i_1 = releaseBranch;
    this.o1i_1 = currentVersionNumber;
    this.p1i_1 = previousVersionNumber;
  }
  protoOf(StatusCheck).toString = function () {
    return 'StatusCheck(gitStatus=' + this.m1i_1 + ', releaseBranch=' + this.n1i_1 + ', currentVersionNumber=' + this.o1i_1 + ', previousVersionNumber=' + this.p1i_1 + ')';
  };
  protoOf(StatusCheck).hashCode = function () {
    var result = this.m1i_1.hashCode();
    result = imul(result, 31) + getStringHashCode(this.n1i_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.o1i_1) | 0;
    result = imul(result, 31) + getStringHashCode(this.p1i_1) | 0;
    return result;
  };
  protoOf(StatusCheck).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof StatusCheck))
      return false;
    var tmp0_other_with_cast = other instanceof StatusCheck ? other : THROW_CCE();
    if (!this.m1i_1.equals(tmp0_other_with_cast.m1i_1))
      return false;
    if (!(this.n1i_1 === tmp0_other_with_cast.n1i_1))
      return false;
    if (!(this.o1i_1 === tmp0_other_with_cast.o1i_1))
      return false;
    if (!(this.p1i_1 === tmp0_other_with_cast.p1i_1))
      return false;
    return true;
  };
  function ChangeType$Major() {
    ChangeType.call(this, 'Major', 0, 3);
    ChangeType_Major_instance = this;
  }
  protoOf(ChangeType$Major).f1j = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.e1(0);
    return '' + (major + 1 | 0) + '.0.0';
  };
  var ChangeType_Major_instance;
  function ChangeType$Minor() {
    ChangeType.call(this, 'Minor', 1, 2);
    ChangeType_Minor_instance = this;
  }
  protoOf(ChangeType$Minor).f1j = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.e1(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.e1(1);
    return '' + major + '.' + (minor + 1 | 0) + '.0';
  };
  var ChangeType_Minor_instance;
  function ChangeType$Patch() {
    ChangeType.call(this, 'Patch', 2, 1);
    ChangeType_Patch_instance = this;
  }
  protoOf(ChangeType$Patch).f1j = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.e1(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.e1(1);
    // Inline function 'kotlin.collections.component3' call
    var patch = components.e1(2);
    return '' + major + '.' + minor + '.' + (patch + 1 | 0);
  };
  var ChangeType_Patch_instance;
  function ChangeType$None() {
    ChangeType.call(this, 'None', 3, 0);
    ChangeType_None_instance = this;
  }
  protoOf(ChangeType$None).f1j = function (components) {
    // Inline function 'kotlin.collections.component1' call
    var major = components.e1(0);
    // Inline function 'kotlin.collections.component2' call
    var minor = components.e1(1);
    // Inline function 'kotlin.collections.component3' call
    var patch = components.e1(2);
    return '' + major + '.' + minor + '.' + patch;
  };
  var ChangeType_None_instance;
  var ChangeType_entriesInitialized;
  function ChangeType_initEntries() {
    if (ChangeType_entriesInitialized)
      return Unit_instance;
    ChangeType_entriesInitialized = true;
    ChangeType_Major_instance = new ChangeType$Major();
    ChangeType_Minor_instance = new ChangeType$Minor();
    ChangeType_Patch_instance = new ChangeType$Patch();
    ChangeType_None_instance = new ChangeType$None();
  }
  function ChangeType(name, ordinal, priority) {
    Enum.call(this, name, ordinal);
    this.e1j_1 = priority;
  }
  function findAppropriateIncrement(gitAdapter, previousTag, implicitPatch, minorRegex) {
    // Inline function 'kotlin.collections.fold' call
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.also' call
    var this_0 = gitAdapter.q1h('HEAD', '^' + previousTag);
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.zegreatrob.tools.tagger.core.findAppropriateIncrement.<anonymous>' call
    if (this_0.a1())
      return null;
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(this_0, 10));
    var tmp0_iterator = this_0.t();
    while (tmp0_iterator.u()) {
      var item = tmp0_iterator.w();
      // Inline function 'com.zegreatrob.tools.tagger.core.findAppropriateIncrement.<anonymous>' call
      var tmp0_elvis_lhs = changeType(item, minorRegex);
      var tmp$ret$1 = tmp0_elvis_lhs == null ? implicitPatch ? ChangeType_Patch_getInstance() : null : tmp0_elvis_lhs;
      destination.q(tmp$ret$1);
    }
    var accumulator = null;
    var tmp0_iterator_0 = destination.t();
    while (tmp0_iterator_0.u()) {
      var element = tmp0_iterator_0.w();
      accumulator = highestPriority(accumulator, element);
    }
    var tmp0_elvis_lhs_0 = accumulator;
    return tmp0_elvis_lhs_0 == null ? implicitPatch ? ChangeType_Patch_getInstance() : ChangeType_None_getInstance() : tmp0_elvis_lhs_0;
  }
  function snapshotReasons(_this__u8e3s4, releaseBranch, currentVersionNumber, previousVersionNumber) {
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.zegreatrob.tools.tagger.core.snapshotReasons.<anonymous>' call
    var statusCheck = new StatusCheck(_this__u8e3s4.b1j_1.r1h(), releaseBranch, currentVersionNumber, previousVersionNumber);
    // Inline function 'kotlin.collections.filter' call
    // Inline function 'kotlin.collections.filterTo' call
    var this_0 = get_entries();
    var destination = ArrayList_init_$Create$_0();
    var tmp0_iterator = this_0.t();
    while (tmp0_iterator.u()) {
      var element = tmp0_iterator.w();
      // Inline function 'com.zegreatrob.tools.tagger.core.snapshotReasons.<anonymous>.<anonymous>' call
      if (element.s1i(statusCheck)) {
        destination.q(element);
      }
    }
    return destination;
  }
  function highestPriority(left, right) {
    return left == null ? right : right == null ? left : left.e1j_1 > right.e1j_1 ? left : right;
  }
  function changeType(_this__u8e3s4, versionRegex) {
    // Inline function 'kotlin.text.trim' call
    var this_0 = _this__u8e3s4.j1h_1;
    var tmp$ret$0 = toString(trim(isCharSequence(this_0) ? this_0 : THROW_CCE()));
    return changeType_0(versionRegex, tmp$ret$0);
  }
  function changeType_0(_this__u8e3s4, message) {
    var tmp;
    var tmp0_safe_receiver = _this__u8e3s4.w1j_1;
    if ((tmp0_safe_receiver == null ? null : tmp0_safe_receiver.b9(message)) === true) {
      tmp = findMatchType(message, _this__u8e3s4.w1j_1);
    } else {
      if (_this__u8e3s4.v1j_1.b9(message)) {
        tmp = ChangeType_Major_getInstance();
      } else {
        if (_this__u8e3s4.u1j_1.b9(message)) {
          tmp = ChangeType_Minor_getInstance();
        } else {
          if (_this__u8e3s4.t1j_1.b9(message)) {
            tmp = ChangeType_Patch_getInstance();
          } else {
            if (_this__u8e3s4.s1j_1.b9(message)) {
              tmp = ChangeType_None_getInstance();
            } else {
              tmp = null;
            }
          }
        }
      }
    }
    return tmp;
  }
  function findMatchType(message, regex) {
    var tmp0_safe_receiver = regex.f9(message);
    var groups = tmp0_safe_receiver == null ? null : tmp0_safe_receiver.w9();
    return groupExists(groups, 'major') ? ChangeType_Major_getInstance() : groupExists(groups, 'minor') ? ChangeType_Minor_getInstance() : groupExists(groups, 'patch') ? ChangeType_Patch_getInstance() : groupExists(groups, 'none') ? ChangeType_None_getInstance() : null;
  }
  function groupExists(_this__u8e3s4, groupName) {
    var tmp$ret$4;
    $l$block: {
      // Inline function 'kotlin.getOrDefault' call
      // Inline function 'kotlin.runCatching' call
      var tmp;
      try {
        // Inline function 'kotlin.Companion.success' call
        // Inline function 'com.zegreatrob.tools.tagger.core.groupExists.<anonymous>' call
        var value = !((_this__u8e3s4 == null ? null : get(_this__u8e3s4, groupName)) == null);
        tmp = _Result___init__impl__xyqfz8(value);
      } catch ($p) {
        var tmp_0;
        if ($p instanceof Error) {
          var e = $p;
          // Inline function 'kotlin.Companion.failure' call
          tmp_0 = _Result___init__impl__xyqfz8(createFailure(e));
        } else {
          throw $p;
        }
        tmp = tmp_0;
      }
      var this_0 = tmp;
      if (_Result___get_isFailure__impl__jpiriv(this_0)) {
        tmp$ret$4 = false;
        break $l$block;
      }
      var tmp_1 = _Result___get_value__impl__bjfvqg(this_0);
      tmp$ret$4 = (tmp_1 == null ? true : !(tmp_1 == null)) ? tmp_1 : THROW_CCE();
    }
    return tmp$ret$4;
  }
  function SnapshotReason_DIRTY_getInstance() {
    SnapshotReason_initEntries();
    return SnapshotReason_DIRTY_instance;
  }
  function SnapshotReason_AHEAD_getInstance() {
    SnapshotReason_initEntries();
    return SnapshotReason_AHEAD_instance;
  }
  function SnapshotReason_BEHIND_getInstance() {
    SnapshotReason_initEntries();
    return SnapshotReason_BEHIND_instance;
  }
  function SnapshotReason_NOT_RELEASE_BRANCH_getInstance() {
    SnapshotReason_initEntries();
    return SnapshotReason_NOT_RELEASE_BRANCH_instance;
  }
  function SnapshotReason_NO_NEW_VERSION_getInstance() {
    SnapshotReason_initEntries();
    return SnapshotReason_NO_NEW_VERSION_instance;
  }
  function ChangeType_Major_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Major_instance;
  }
  function ChangeType_Minor_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Minor_instance;
  }
  function ChangeType_Patch_getInstance() {
    ChangeType_initEntries();
    return ChangeType_Patch_instance;
  }
  function ChangeType_None_getInstance() {
    ChangeType_initEntries();
    return ChangeType_None_instance;
  }
  function lastVersionAndTag(_this__u8e3s4) {
    var tmp0_elvis_lhs = _this__u8e3s4.b1j_1.s1h(0);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      return null;
    } else {
      tmp = tmp0_elvis_lhs;
    }
    var description = tmp;
    var tmp_0;
    if (contains(description, '-')) {
      tmp_0 = substringBefore(description, '-');
    } else {
      tmp_0 = description;
    }
    var previousVersionNumber = tmp_0;
    // Inline function 'kotlin.text.ifEmpty' call
    var tmp_1;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(previousVersionNumber) === 0) {
      // Inline function 'com.zegreatrob.tools.tagger.core.lastVersionAndTag.<anonymous>' call
      tmp_1 = null;
    } else {
      tmp_1 = previousVersionNumber;
    }
    var tmp1_safe_receiver = tmp_1;
    var tmp_2;
    if (tmp1_safe_receiver == null) {
      tmp_2 = null;
    } else {
      // Inline function 'kotlin.let' call
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.zegreatrob.tools.tagger.core.lastVersionAndTag.<anonymous>' call
      tmp_2 = to(tmp1_safe_receiver, description);
    }
    return tmp_2;
  }
  function tag(_this__u8e3s4, version, releaseBranch, userName, userEmail) {
    var isSnapshot_0 = isSnapshot(version);
    var headTag = _this__u8e3s4.b1j_1.p1h('HEAD');
    var alreadyTagged = !(headTag == null);
    var headBranch = _this__u8e3s4.b1j_1.r1h().w1h_1;
    var isNotOnReleaseBranch = !(headBranch === releaseBranch);
    var tmp;
    if ((isSnapshot_0 ? true : alreadyTagged) ? true : isNotOnReleaseBranch) {
      var tmp_0 = TagErrors_instance;
      // Inline function 'kotlin.collections.filterKeys' call
      var tmp_1 = to(isSnapshot_0, 'being snapshot');
      var tmp_2 = TagErrors_instance;
      var this_0 = mapOf([tmp_1, to(alreadyTagged, tmp_2.y1j(headTag == null ? null : headTag.y1h_1)), to(isNotOnReleaseBranch, TagErrors_instance.z1j(releaseBranch, headBranch))]);
      var result = LinkedHashMap_init_$Create$();
      // Inline function 'kotlin.collections.iterator' call
      var tmp0_iterator = this_0.p2().t();
      while (tmp0_iterator.u()) {
        var entry = tmp0_iterator.w();
        // Inline function 'com.zegreatrob.tools.tagger.core.tag.<anonymous>' call
        if (entry.q2()) {
          result.n2(entry.q2(), entry.r2());
        }
      }
      tmp = new Error_0(tmp_0.a1k(joinToString(result.m2(), ', ')));
    } else {
      // Inline function 'kotlin.getOrElse' call
      // Inline function 'kotlin.map' call
      // Inline function 'kotlin.runCatching' call
      var tmp_3;
      try {
        // Inline function 'kotlin.Companion.success' call
        _this__u8e3s4.b1j_1.n1h(version, 'HEAD', userName, userEmail);
        tmp_3 = _Result___init__impl__xyqfz8(Unit_instance);
      } catch ($p) {
        var tmp_4;
        if ($p instanceof Error) {
          var e = $p;
          // Inline function 'kotlin.Companion.failure' call
          tmp_4 = _Result___init__impl__xyqfz8(createFailure(e));
        } else {
          throw $p;
        }
        tmp_3 = tmp_4;
      }
      var this_1 = tmp_3;
      // Inline function 'kotlin.contracts.contract' call
      var tmp_5;
      if (_Result___get_isSuccess__impl__sndoy8(this_1)) {
        // Inline function 'kotlin.Companion.success' call
        // Inline function 'com.zegreatrob.tools.tagger.core.tag.<anonymous>' call
        var tmp_6 = _Result___get_value__impl__bjfvqg(this_1);
        (tmp_6 == null ? true : !(tmp_6 == null)) || THROW_CCE();
        _this__u8e3s4.b1j_1.o1h();
        var value = Success_getInstance();
        tmp_5 = _Result___init__impl__xyqfz8(value);
      } else {
        tmp_5 = _Result___init__impl__xyqfz8(_Result___get_value__impl__bjfvqg(this_1));
      }
      var this_2 = tmp_5;
      // Inline function 'kotlin.contracts.contract' call
      var exception = Result__exceptionOrNull_impl_p6xea9(this_2);
      var tmp_7;
      if (exception == null) {
        var tmp_8 = _Result___get_value__impl__bjfvqg(this_2);
        tmp_7 = (tmp_8 == null ? true : !(tmp_8 == null)) ? tmp_8 : THROW_CCE();
      } else {
        // Inline function 'com.zegreatrob.tools.tagger.core.tag.<anonymous>' call
        var tmp0_elvis_lhs = exception.message;
        tmp_7 = new Error_0(tmp0_elvis_lhs == null ? 'Unknown error during tagging' : tmp0_elvis_lhs);
      }
      tmp = tmp_7;
    }
    return tmp;
  }
  function isSnapshot(_this__u8e3s4) {
    return contains(_this__u8e3s4, 'SNAPSHOT');
  }
  function TagErrors() {
    this.x1j_1 = 'being snapshot';
  }
  protoOf(TagErrors).a1k = function (messages) {
    return 'skipping tag due to ' + messages;
  };
  protoOf(TagErrors).y1j = function (headTag) {
    return 'already tagged ' + headTag;
  };
  protoOf(TagErrors).z1j = function (releaseBranch, headBranch) {
    return 'not on release branch ' + releaseBranch + ' - branch was ' + headBranch;
  };
  var TagErrors_instance;
  function TagErrors_getInstance() {
    return TagErrors_instance;
  }
  function Success() {
    Success_instance = this;
    TagResult.call(this);
  }
  protoOf(Success).toString = function () {
    return 'Success';
  };
  protoOf(Success).hashCode = function () {
    return -888110432;
  };
  protoOf(Success).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Success))
      return false;
    other instanceof Success || THROW_CCE();
    return true;
  };
  var Success_instance;
  function Success_getInstance() {
    if (Success_instance == null)
      new Success();
    return Success_instance;
  }
  function Error_0(message) {
    TagResult.call(this);
    this.b1k_1 = message;
  }
  protoOf(Error_0).toString = function () {
    return 'Error(message=' + this.b1k_1 + ')';
  };
  protoOf(Error_0).hashCode = function () {
    return getStringHashCode(this.b1k_1);
  };
  protoOf(Error_0).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Error_0))
      return false;
    var tmp0_other_with_cast = other instanceof Error_0 ? other : THROW_CCE();
    if (!(this.b1k_1 === tmp0_other_with_cast.b1k_1))
      return false;
    return true;
  };
  function TagResult() {
  }
  function TaggerCore(adapter) {
    this.b1j_1 = adapter;
  }
  protoOf(TaggerCore).toString = function () {
    return 'TaggerCore(adapter=' + this.b1j_1 + ')';
  };
  protoOf(TaggerCore).hashCode = function () {
    return hashCode(this.b1j_1);
  };
  protoOf(TaggerCore).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof TaggerCore))
      return false;
    var tmp0_other_with_cast = other instanceof TaggerCore ? other : THROW_CCE();
    if (!equals(this.b1j_1, tmp0_other_with_cast.b1j_1))
      return false;
    return true;
  };
  function Defaults() {
    Defaults_instance = this;
    this.c1k_1 = Defaults_getInstance().e1i_1;
    this.d1k_1 = Defaults_getInstance().d1i_1;
    this.e1k_1 = Defaults_getInstance().c1i_1;
    this.f1k_1 = Defaults_getInstance().b1i_1;
  }
  var Defaults_instance;
  function Defaults_getInstance_0() {
    if (Defaults_instance == null)
      new Defaults();
    return Defaults_instance;
  }
  function Companion() {
    this.g1k_1 = "version regex must include groups named 'major', 'minor', 'patch', and 'none'.";
  }
  protoOf(Companion).h1k = function (regexPattern) {
    return ((contains(regexPattern, '?<major>') ? contains(regexPattern, '?<minor>') : false) ? contains(regexPattern, '?<patch>') : false) ? contains(regexPattern, '?<none>') : false;
  };
  var Companion_instance_0;
  function Companion_getInstance() {
    return Companion_instance_0;
  }
  function VersionRegex(none, patch, minor, major, unified) {
    this.s1j_1 = none;
    this.t1j_1 = patch;
    this.u1j_1 = minor;
    this.v1j_1 = major;
    this.w1j_1 = unified;
  }
  protoOf(VersionRegex).toString = function () {
    return 'VersionRegex(none=' + this.s1j_1 + ', patch=' + this.t1j_1 + ', minor=' + this.u1j_1 + ', major=' + this.v1j_1 + ', unified=' + this.w1j_1 + ')';
  };
  protoOf(VersionRegex).hashCode = function () {
    var result = hashCode(this.s1j_1);
    result = imul(result, 31) + hashCode(this.t1j_1) | 0;
    result = imul(result, 31) + hashCode(this.u1j_1) | 0;
    result = imul(result, 31) + hashCode(this.v1j_1) | 0;
    result = imul(result, 31) + (this.w1j_1 == null ? 0 : hashCode(this.w1j_1)) | 0;
    return result;
  };
  protoOf(VersionRegex).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof VersionRegex))
      return false;
    var tmp0_other_with_cast = other instanceof VersionRegex ? other : THROW_CCE();
    if (!equals(this.s1j_1, tmp0_other_with_cast.s1j_1))
      return false;
    if (!equals(this.t1j_1, tmp0_other_with_cast.t1j_1))
      return false;
    if (!equals(this.u1j_1, tmp0_other_with_cast.u1j_1))
      return false;
    if (!equals(this.v1j_1, tmp0_other_with_cast.v1j_1))
      return false;
    if (!equals(this.w1j_1, tmp0_other_with_cast.w1j_1))
      return false;
    return true;
  };
  //region block: init
  TagErrors_instance = new TagErrors();
  Companion_instance_0 = new Companion();
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = Error_0;
  _.$_$.b = TaggerCore;
  _.$_$.c = VersionRegex;
  _.$_$.d = calculateNextVersion;
  _.$_$.e = tag;
  _.$_$.f = Success_getInstance;
  _.$_$.g = Companion_instance_0;
  _.$_$.h = Defaults_getInstance_0;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js'), require('./tools-digger-core.js')));

//# sourceMappingURL=tools-tagger-core.js.map
